/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.datastructure;

import org.citygml4j.factory.GMLGeometryFactory;
import org.citygml4j.model.citygml.core.AbstractCityObject;
import org.citygml4j.model.citygml.vegetation.AbstractVegetationObject;
import org.citygml4j.model.citygml.vegetation.PlantCover;
import org.citygml4j.model.citygml.vegetation.SolitaryVegetationObject;
import org.citygml4j.model.gml.geometry.aggregates.MultiSolid;
import org.citygml4j.model.gml.geometry.aggregates.MultiSolidProperty;
import org.citygml4j.model.gml.geometry.aggregates.MultiSurface;
import org.citygml4j.model.gml.geometry.aggregates.MultiSurfaceProperty;
import org.citygml4j.model.gml.geometry.primitives.Solid;
import org.citygml4j.model.gml.geometry.primitives.SolidProperty;

import de.hft.stuttgart.citydoctor2.check.Check;
import de.hft.stuttgart.citydoctor2.parser.ParserConfiguration;
import de.hft.stuttgart.citydoctor2.utils.CityGmlUtils;

/**
 * Representation of CityGML vegetation objects
 * 
 * @author Matthias Betz
 *
 */
public class Vegetation extends CityObject {

	private static final long serialVersionUID = -5136358065541704146L;

	public enum VegetationType {
		SOLITARY_VEGETATION_OBJECT, PLANT_COVER
	}

	private AbstractVegetationObject citygmlVegetation;
	private VegetationType type;

	public Vegetation(VegetationType type) {
		this.type = type;
	}

	@Override
	public FeatureType getFeatureType() {
		return FeatureType.VEGETATION;
	}

	@Override
	public void reCreateGeometries(GMLGeometryFactory factory, ParserConfiguration config) {
		for (Geometry geom : getGeometries()) {
			if (geom.getType() == GeometryType.MULTI_SURFACE) {
				MultiSurface ms = CityGmlUtils.createMultiSurface(geom, factory, config);
				if (type == VegetationType.SOLITARY_VEGETATION_OBJECT) {
					SolitaryVegetationObject svo = (SolitaryVegetationObject) citygmlVegetation;
					setMultiSurfaceAccordingToLod(svo, ms, geom.getLod());
				} else {
					PlantCover pc = (PlantCover) citygmlVegetation;
					setMultiSurfaceAccordingToLod(pc, ms, geom.getLod());
				}
			} else {
				Solid solid = CityGmlUtils.createSolid(geom, factory, config);
				if (type == VegetationType.SOLITARY_VEGETATION_OBJECT) {
					SolitaryVegetationObject svo = (SolitaryVegetationObject) citygmlVegetation;
					setSolidAccordingToLod(svo, solid, geom.getLod());
				} else {
					PlantCover pc = (PlantCover) citygmlVegetation;
					setSolidAccordingToLod(pc, solid, geom.getLod());
				}
			}
		}
	}

	private void setSolidAccordingToLod(PlantCover pc, Solid solid, Lod lod) {
		switch (lod) {
		case LOD1:
			pc.setLod1MultiSolid(new MultiSolidProperty(new MultiSolid(solid)));
			break;
		case LOD2:
			pc.setLod2MultiSolid(new MultiSolidProperty(new MultiSolid(solid)));
			break;
		case LOD3:
			pc.setLod3MultiSolid(new MultiSolidProperty(new MultiSolid(solid)));
			break;
		case LOD4:
			pc.setLod4MultiSolid(new MultiSolidProperty(new MultiSolid(solid)));
			break;
		default:
			throw new IllegalStateException("Cannot set Solid with lod to PlantCover:" + lod);
		}
	}

	private void setSolidAccordingToLod(SolitaryVegetationObject svo, Solid solid, Lod lod) {
		switch (lod) {
		case LOD1:
			svo.setLod1Geometry(new SolidProperty(solid));
			break;
		case LOD2:
			svo.setLod2Geometry(new SolidProperty(solid));
			break;
		case LOD3:
			svo.setLod3Geometry(new SolidProperty(solid));
			break;
		case LOD4:
			svo.setLod4Geometry(new SolidProperty(solid));
			break;
		default:
			throw new IllegalStateException("Cannot set Solid with lod to SolitaryVegetationObject:" + lod);
		}
	}

	private void setMultiSurfaceAccordingToLod(PlantCover pc, MultiSurface ms, Lod lod) {
		switch (lod) {
		case LOD1:
			pc.setLod1MultiSurface(new MultiSurfaceProperty(ms));
			break;
		case LOD2:
			pc.setLod2MultiSurface(new MultiSurfaceProperty(ms));
			break;
		case LOD3:
			pc.setLod3MultiSurface(new MultiSurfaceProperty(ms));
			break;
		case LOD4:
			pc.setLod4MultiSurface(new MultiSurfaceProperty(ms));
			break;
		default:
			throw new IllegalStateException("Cannot set MultiSurface with lod to PlantCover:" + lod);
		}

	}

	private void setMultiSurfaceAccordingToLod(SolitaryVegetationObject svo, MultiSurface ms, Lod lod) {
		switch (lod) {
		case LOD1:
			svo.setLod1Geometry(new MultiSurfaceProperty(ms));
			break;
		case LOD2:
			svo.setLod2Geometry(new MultiSurfaceProperty(ms));
			break;
		case LOD3:
			svo.setLod3Geometry(new MultiSurfaceProperty(ms));
			break;
		case LOD4:
			svo.setLod4Geometry(new MultiSurfaceProperty(ms));
			break;
		default:
			throw new IllegalStateException("Cannot set MultiSurface with lod to SolitaryVegetationObject:" + lod);
		}
	}

	@Override
	public void accept(Check c) {
		super.accept(c);
		if (c.canExecute(this)) {
			c.check(this);
		}
	}

	@Override
	public AbstractCityObject getGmlObject() {
		return citygmlVegetation;
	}

	@Override
	public void unsetGmlGeometries() {
		if (type == VegetationType.SOLITARY_VEGETATION_OBJECT) {
			SolitaryVegetationObject svo = (SolitaryVegetationObject) citygmlVegetation;
			svo.unsetLod1Geometry();
			svo.unsetLod2Geometry();
			svo.unsetLod3Geometry();
			svo.unsetLod4Geometry();
		} else {
			PlantCover pc = (PlantCover) citygmlVegetation;
			pc.unsetLod1MultiSurface();
			pc.unsetLod2MultiSurface();
			pc.unsetLod3MultiSurface();
			pc.unsetLod4MultiSurface();
		}
	}

	public void setGmlObject(AbstractVegetationObject avo) {
		citygmlVegetation = avo;
	}

	public VegetationType getVegetationType() {
		return type;
	}

	@Override
	public String toString() {
		return "Vegetation [id=" + getGmlId() + "]";
	}

}
